# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc
import warnings

from google.iam.admin.v1 import iam_pb2 as google_dot_iam_dot_admin_dot_v1_dot_iam__pb2
from google.iam.v1 import iam_policy_pb2 as google_dot_iam_dot_v1_dot_iam__policy__pb2
from google.iam.v1 import policy_pb2 as google_dot_iam_dot_v1_dot_policy__pb2
from google.protobuf import empty_pb2 as google_dot_protobuf_dot_empty__pb2

GRPC_GENERATED_VERSION = '1.64.1'
GRPC_VERSION = grpc.__version__
EXPECTED_ERROR_RELEASE = '1.65.0'
SCHEDULED_RELEASE_DATE = 'June 25, 2024'
_version_not_supported = False

try:
    from grpc._utilities import first_version_is_lower
    _version_not_supported = first_version_is_lower(GRPC_VERSION, GRPC_GENERATED_VERSION)
except ImportError:
    _version_not_supported = True

if _version_not_supported:
    warnings.warn(
        f'The grpc package installed is at version {GRPC_VERSION},'
        + f' but the generated code in google/iam/admin/v1/iam_pb2_grpc.py depends on'
        + f' grpcio>={GRPC_GENERATED_VERSION}.'
        + f' Please upgrade your grpc module to grpcio>={GRPC_GENERATED_VERSION}'
        + f' or downgrade your generated code using grpcio-tools<={GRPC_VERSION}.'
        + f' This warning will become an error in {EXPECTED_ERROR_RELEASE},'
        + f' scheduled for release on {SCHEDULED_RELEASE_DATE}.',
        RuntimeWarning
    )


class IAMStub(object):
    """Creates and manages Identity and Access Management (IAM) resources.

    You can use this service to work with all of the following resources:

    * **Service accounts**, which identify an application or a virtual machine
    (VM) instance rather than a person
    * **Service account keys**, which service accounts use to authenticate with
    Google APIs
    * **IAM policies for service accounts**, which specify the roles that a
    principal has for the service account
    * **IAM custom roles**, which help you limit the number of permissions that
    you grant to principals

    In addition, you can use this service to complete the following tasks, among
    others:

    * Test whether a service account can use specific permissions
    * Check which roles you can grant for a specific resource
    * Lint, or validate, condition expressions in an IAM policy

    When you read data from the IAM API, each read is eventually consistent. In
    other words, if you write data with the IAM API, then immediately read that
    data, the read operation might return an older version of the data. To deal
    with this behavior, your application can retry the request with truncated
    exponential backoff.

    In contrast, writing data to the IAM API is sequentially consistent. In other
    words, write operations are always processed in the order in which they were
    received.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.ListServiceAccounts = channel.unary_unary(
                '/google.iam.admin.v1.IAM/ListServiceAccounts',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountsRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountsResponse.FromString,
                _registered_method=True)
        self.GetServiceAccount = channel.unary_unary(
                '/google.iam.admin.v1.IAM/GetServiceAccount',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.GetServiceAccountRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.FromString,
                _registered_method=True)
        self.CreateServiceAccount = channel.unary_unary(
                '/google.iam.admin.v1.IAM/CreateServiceAccount',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.CreateServiceAccountRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.FromString,
                _registered_method=True)
        self.UpdateServiceAccount = channel.unary_unary(
                '/google.iam.admin.v1.IAM/UpdateServiceAccount',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.FromString,
                _registered_method=True)
        self.PatchServiceAccount = channel.unary_unary(
                '/google.iam.admin.v1.IAM/PatchServiceAccount',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.PatchServiceAccountRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.FromString,
                _registered_method=True)
        self.DeleteServiceAccount = channel.unary_unary(
                '/google.iam.admin.v1.IAM/DeleteServiceAccount',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DeleteServiceAccountRequest.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                _registered_method=True)
        self.UndeleteServiceAccount = channel.unary_unary(
                '/google.iam.admin.v1.IAM/UndeleteServiceAccount',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UndeleteServiceAccountRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UndeleteServiceAccountResponse.FromString,
                _registered_method=True)
        self.EnableServiceAccount = channel.unary_unary(
                '/google.iam.admin.v1.IAM/EnableServiceAccount',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.EnableServiceAccountRequest.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                _registered_method=True)
        self.DisableServiceAccount = channel.unary_unary(
                '/google.iam.admin.v1.IAM/DisableServiceAccount',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DisableServiceAccountRequest.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                _registered_method=True)
        self.ListServiceAccountKeys = channel.unary_unary(
                '/google.iam.admin.v1.IAM/ListServiceAccountKeys',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountKeysRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountKeysResponse.FromString,
                _registered_method=True)
        self.GetServiceAccountKey = channel.unary_unary(
                '/google.iam.admin.v1.IAM/GetServiceAccountKey',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.GetServiceAccountKeyRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccountKey.FromString,
                _registered_method=True)
        self.CreateServiceAccountKey = channel.unary_unary(
                '/google.iam.admin.v1.IAM/CreateServiceAccountKey',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.CreateServiceAccountKeyRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccountKey.FromString,
                _registered_method=True)
        self.UploadServiceAccountKey = channel.unary_unary(
                '/google.iam.admin.v1.IAM/UploadServiceAccountKey',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UploadServiceAccountKeyRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccountKey.FromString,
                _registered_method=True)
        self.DeleteServiceAccountKey = channel.unary_unary(
                '/google.iam.admin.v1.IAM/DeleteServiceAccountKey',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DeleteServiceAccountKeyRequest.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                _registered_method=True)
        self.DisableServiceAccountKey = channel.unary_unary(
                '/google.iam.admin.v1.IAM/DisableServiceAccountKey',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DisableServiceAccountKeyRequest.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                _registered_method=True)
        self.EnableServiceAccountKey = channel.unary_unary(
                '/google.iam.admin.v1.IAM/EnableServiceAccountKey',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.EnableServiceAccountKeyRequest.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                _registered_method=True)
        self.SignBlob = channel.unary_unary(
                '/google.iam.admin.v1.IAM/SignBlob',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignBlobRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignBlobResponse.FromString,
                _registered_method=True)
        self.SignJwt = channel.unary_unary(
                '/google.iam.admin.v1.IAM/SignJwt',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignJwtRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignJwtResponse.FromString,
                _registered_method=True)
        self.GetIamPolicy = channel.unary_unary(
                '/google.iam.admin.v1.IAM/GetIamPolicy',
                request_serializer=google_dot_iam_dot_v1_dot_iam__policy__pb2.GetIamPolicyRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_v1_dot_policy__pb2.Policy.FromString,
                _registered_method=True)
        self.SetIamPolicy = channel.unary_unary(
                '/google.iam.admin.v1.IAM/SetIamPolicy',
                request_serializer=google_dot_iam_dot_v1_dot_iam__policy__pb2.SetIamPolicyRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_v1_dot_policy__pb2.Policy.FromString,
                _registered_method=True)
        self.TestIamPermissions = channel.unary_unary(
                '/google.iam.admin.v1.IAM/TestIamPermissions',
                request_serializer=google_dot_iam_dot_v1_dot_iam__policy__pb2.TestIamPermissionsRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_v1_dot_iam__policy__pb2.TestIamPermissionsResponse.FromString,
                _registered_method=True)
        self.QueryGrantableRoles = channel.unary_unary(
                '/google.iam.admin.v1.IAM/QueryGrantableRoles',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryGrantableRolesRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryGrantableRolesResponse.FromString,
                _registered_method=True)
        self.ListRoles = channel.unary_unary(
                '/google.iam.admin.v1.IAM/ListRoles',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListRolesRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListRolesResponse.FromString,
                _registered_method=True)
        self.GetRole = channel.unary_unary(
                '/google.iam.admin.v1.IAM/GetRole',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.GetRoleRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
                _registered_method=True)
        self.CreateRole = channel.unary_unary(
                '/google.iam.admin.v1.IAM/CreateRole',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.CreateRoleRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
                _registered_method=True)
        self.UpdateRole = channel.unary_unary(
                '/google.iam.admin.v1.IAM/UpdateRole',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UpdateRoleRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
                _registered_method=True)
        self.DeleteRole = channel.unary_unary(
                '/google.iam.admin.v1.IAM/DeleteRole',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DeleteRoleRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
                _registered_method=True)
        self.UndeleteRole = channel.unary_unary(
                '/google.iam.admin.v1.IAM/UndeleteRole',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UndeleteRoleRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
                _registered_method=True)
        self.QueryTestablePermissions = channel.unary_unary(
                '/google.iam.admin.v1.IAM/QueryTestablePermissions',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryTestablePermissionsRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryTestablePermissionsResponse.FromString,
                _registered_method=True)
        self.QueryAuditableServices = channel.unary_unary(
                '/google.iam.admin.v1.IAM/QueryAuditableServices',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryAuditableServicesRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryAuditableServicesResponse.FromString,
                _registered_method=True)
        self.LintPolicy = channel.unary_unary(
                '/google.iam.admin.v1.IAM/LintPolicy',
                request_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.LintPolicyRequest.SerializeToString,
                response_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.LintPolicyResponse.FromString,
                _registered_method=True)


class IAMServicer(object):
    """Creates and manages Identity and Access Management (IAM) resources.

    You can use this service to work with all of the following resources:

    * **Service accounts**, which identify an application or a virtual machine
    (VM) instance rather than a person
    * **Service account keys**, which service accounts use to authenticate with
    Google APIs
    * **IAM policies for service accounts**, which specify the roles that a
    principal has for the service account
    * **IAM custom roles**, which help you limit the number of permissions that
    you grant to principals

    In addition, you can use this service to complete the following tasks, among
    others:

    * Test whether a service account can use specific permissions
    * Check which roles you can grant for a specific resource
    * Lint, or validate, condition expressions in an IAM policy

    When you read data from the IAM API, each read is eventually consistent. In
    other words, if you write data with the IAM API, then immediately read that
    data, the read operation might return an older version of the data. To deal
    with this behavior, your application can retry the request with truncated
    exponential backoff.

    In contrast, writing data to the IAM API is sequentially consistent. In other
    words, write operations are always processed in the order in which they were
    received.
    """

    def ListServiceAccounts(self, request, context):
        """Lists every [ServiceAccount][google.iam.admin.v1.ServiceAccount] that belongs to a specific project.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetServiceAccount(self, request, context):
        """Gets a [ServiceAccount][google.iam.admin.v1.ServiceAccount].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def CreateServiceAccount(self, request, context):
        """Creates a [ServiceAccount][google.iam.admin.v1.ServiceAccount].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def UpdateServiceAccount(self, request, context):
        """**Note:** We are in the process of deprecating this method. Use
        [PatchServiceAccount][google.iam.admin.v1.IAM.PatchServiceAccount] instead.

        Updates a [ServiceAccount][google.iam.admin.v1.ServiceAccount].

        You can update only the `display_name` field.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def PatchServiceAccount(self, request, context):
        """Patches a [ServiceAccount][google.iam.admin.v1.ServiceAccount].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeleteServiceAccount(self, request, context):
        """Deletes a [ServiceAccount][google.iam.admin.v1.ServiceAccount].

        **Warning:** After you delete a service account, you might not be able to
        undelete it. If you know that you need to re-enable the service account in
        the future, use [DisableServiceAccount][google.iam.admin.v1.IAM.DisableServiceAccount] instead.

        If you delete a service account, IAM permanently removes the service
        account 30 days later. Google Cloud cannot recover the service account
        after it is permanently removed, even if you file a support request.

        To help avoid unplanned outages, we recommend that you disable the service
        account before you delete it. Use [DisableServiceAccount][google.iam.admin.v1.IAM.DisableServiceAccount] to disable the
        service account, then wait at least 24 hours and watch for unintended
        consequences. If there are no unintended consequences, you can delete the
        service account.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def UndeleteServiceAccount(self, request, context):
        """Restores a deleted [ServiceAccount][google.iam.admin.v1.ServiceAccount].

        **Important:** It is not always possible to restore a deleted service
        account. Use this method only as a last resort.

        After you delete a service account, IAM permanently removes the service
        account 30 days later. There is no way to restore a deleted service account
        that has been permanently removed.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def EnableServiceAccount(self, request, context):
        """Enables a [ServiceAccount][google.iam.admin.v1.ServiceAccount] that was disabled by
        [DisableServiceAccount][google.iam.admin.v1.IAM.DisableServiceAccount].

        If the service account is already enabled, then this method has no effect.

        If the service account was disabled by other means—for example, if Google
        disabled the service account because it was compromised—you cannot use this
        method to enable the service account.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DisableServiceAccount(self, request, context):
        """Disables a [ServiceAccount][google.iam.admin.v1.ServiceAccount] immediately.

        If an application uses the service account to authenticate, that
        application can no longer call Google APIs or access Google Cloud
        resources. Existing access tokens for the service account are rejected, and
        requests for new access tokens will fail.

        To re-enable the service account, use [EnableServiceAccount][google.iam.admin.v1.IAM.EnableServiceAccount]. After you
        re-enable the service account, its existing access tokens will be accepted,
        and you can request new access tokens.

        To help avoid unplanned outages, we recommend that you disable the service
        account before you delete it. Use this method to disable the service
        account, then wait at least 24 hours and watch for unintended consequences.
        If there are no unintended consequences, you can delete the service account
        with [DeleteServiceAccount][google.iam.admin.v1.IAM.DeleteServiceAccount].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ListServiceAccountKeys(self, request, context):
        """Lists every [ServiceAccountKey][google.iam.admin.v1.ServiceAccountKey] for a service account.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetServiceAccountKey(self, request, context):
        """Gets a [ServiceAccountKey][google.iam.admin.v1.ServiceAccountKey].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def CreateServiceAccountKey(self, request, context):
        """Creates a [ServiceAccountKey][google.iam.admin.v1.ServiceAccountKey].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def UploadServiceAccountKey(self, request, context):
        """Uploads the public key portion of a key pair that you manage, and
        associates the public key with a [ServiceAccount][google.iam.admin.v1.ServiceAccount].

        After you upload the public key, you can use the private key from the key
        pair as a service account key.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeleteServiceAccountKey(self, request, context):
        """Deletes a [ServiceAccountKey][google.iam.admin.v1.ServiceAccountKey]. Deleting a service account key does not
        revoke short-lived credentials that have been issued based on the service
        account key.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DisableServiceAccountKey(self, request, context):
        """Disable a [ServiceAccountKey][google.iam.admin.v1.ServiceAccountKey]. A disabled service account key can be
        re-enabled with [EnableServiceAccountKey][google.iam.admin.v1.IAM.EnableServiceAccountKey].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def EnableServiceAccountKey(self, request, context):
        """Enable a [ServiceAccountKey][google.iam.admin.v1.ServiceAccountKey].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def SignBlob(self, request, context):
        """**Note:** This method is deprecated. Use the
        [`signBlob`](https://cloud.google.com/iam/help/rest-credentials/v1/projects.serviceAccounts/signBlob)
        method in the IAM Service Account Credentials API instead. If you currently
        use this method, see the [migration
        guide](https://cloud.google.com/iam/help/credentials/migrate-api) for
        instructions.

        Signs a blob using the system-managed private key for a [ServiceAccount][google.iam.admin.v1.ServiceAccount].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def SignJwt(self, request, context):
        """**Note:** This method is deprecated. Use the
        [`signJwt`](https://cloud.google.com/iam/help/rest-credentials/v1/projects.serviceAccounts/signJwt)
        method in the IAM Service Account Credentials API instead. If you currently
        use this method, see the [migration
        guide](https://cloud.google.com/iam/help/credentials/migrate-api) for
        instructions.

        Signs a JSON Web Token (JWT) using the system-managed private key for a
        [ServiceAccount][google.iam.admin.v1.ServiceAccount].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetIamPolicy(self, request, context):
        """Gets the IAM policy that is attached to a [ServiceAccount][google.iam.admin.v1.ServiceAccount]. This IAM
        policy specifies which principals have access to the service account.

        This method does not tell you whether the service account has been granted
        any roles on other resources. To check whether a service account has role
        grants on a resource, use the `getIamPolicy` method for that resource. For
        example, to view the role grants for a project, call the Resource Manager
        API's
        [`projects.getIamPolicy`](https://cloud.google.com/resource-manager/reference/rest/v1/projects/getIamPolicy)
        method.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def SetIamPolicy(self, request, context):
        """Sets the IAM policy that is attached to a [ServiceAccount][google.iam.admin.v1.ServiceAccount].

        Use this method to grant or revoke access to the service account. For
        example, you could grant a principal the ability to impersonate the service
        account.

        This method does not enable the service account to access other resources.
        To grant roles to a service account on a resource, follow these steps:

        1. Call the resource's `getIamPolicy` method to get its current IAM policy.
        2. Edit the policy so that it binds the service account to an IAM role for
        the resource.
        3. Call the resource's `setIamPolicy` method to update its IAM policy.

        For detailed instructions, see
        [Manage access to project, folders, and
        organizations](https://cloud.google.com/iam/help/service-accounts/granting-access-to-service-accounts)
        or [Manage access to other
        resources](https://cloud.google.com/iam/help/access/manage-other-resources).
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def TestIamPermissions(self, request, context):
        """Tests whether the caller has the specified permissions on a
        [ServiceAccount][google.iam.admin.v1.ServiceAccount].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def QueryGrantableRoles(self, request, context):
        """Lists roles that can be granted on a Google Cloud resource. A role is
        grantable if the IAM policy for the resource can contain bindings to the
        role.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ListRoles(self, request, context):
        """Lists every predefined [Role][google.iam.admin.v1.Role] that IAM supports, or every custom role
        that is defined for an organization or project.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetRole(self, request, context):
        """Gets the definition of a [Role][google.iam.admin.v1.Role].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def CreateRole(self, request, context):
        """Creates a new custom [Role][google.iam.admin.v1.Role].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def UpdateRole(self, request, context):
        """Updates the definition of a custom [Role][google.iam.admin.v1.Role].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeleteRole(self, request, context):
        """Deletes a custom [Role][google.iam.admin.v1.Role].

        When you delete a custom role, the following changes occur immediately:

        * You cannot bind a principal to the custom role in an IAM
        [Policy][google.iam.v1.Policy].
        * Existing bindings to the custom role are not changed, but they have no
        effect.
        * By default, the response from [ListRoles][google.iam.admin.v1.IAM.ListRoles] does not include the custom
        role.

        You have 7 days to undelete the custom role. After 7 days, the following
        changes occur:

        * The custom role is permanently deleted and cannot be recovered.
        * If an IAM policy contains a binding to the custom role, the binding is
        permanently removed.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def UndeleteRole(self, request, context):
        """Undeletes a custom [Role][google.iam.admin.v1.Role].
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def QueryTestablePermissions(self, request, context):
        """Lists every permission that you can test on a resource. A permission is
        testable if you can check whether a principal has that permission on the
        resource.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def QueryAuditableServices(self, request, context):
        """Returns a list of services that allow you to opt into audit logs that are
        not generated by default.

        To learn more about audit logs, see the [Logging
        documentation](https://cloud.google.com/logging/docs/audit).
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def LintPolicy(self, request, context):
        """Lints, or validates, an IAM policy. Currently checks the
        [google.iam.v1.Binding.condition][google.iam.v1.Binding.condition] field, which contains a condition
        expression for a role binding.

        Successful calls to this method always return an HTTP `200 OK` status code,
        even if the linter detects an issue in the IAM policy.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_IAMServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'ListServiceAccounts': grpc.unary_unary_rpc_method_handler(
                    servicer.ListServiceAccounts,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountsRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountsResponse.SerializeToString,
            ),
            'GetServiceAccount': grpc.unary_unary_rpc_method_handler(
                    servicer.GetServiceAccount,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.GetServiceAccountRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.SerializeToString,
            ),
            'CreateServiceAccount': grpc.unary_unary_rpc_method_handler(
                    servicer.CreateServiceAccount,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.CreateServiceAccountRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.SerializeToString,
            ),
            'UpdateServiceAccount': grpc.unary_unary_rpc_method_handler(
                    servicer.UpdateServiceAccount,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.SerializeToString,
            ),
            'PatchServiceAccount': grpc.unary_unary_rpc_method_handler(
                    servicer.PatchServiceAccount,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.PatchServiceAccountRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.SerializeToString,
            ),
            'DeleteServiceAccount': grpc.unary_unary_rpc_method_handler(
                    servicer.DeleteServiceAccount,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DeleteServiceAccountRequest.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
            'UndeleteServiceAccount': grpc.unary_unary_rpc_method_handler(
                    servicer.UndeleteServiceAccount,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UndeleteServiceAccountRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UndeleteServiceAccountResponse.SerializeToString,
            ),
            'EnableServiceAccount': grpc.unary_unary_rpc_method_handler(
                    servicer.EnableServiceAccount,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.EnableServiceAccountRequest.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
            'DisableServiceAccount': grpc.unary_unary_rpc_method_handler(
                    servicer.DisableServiceAccount,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DisableServiceAccountRequest.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
            'ListServiceAccountKeys': grpc.unary_unary_rpc_method_handler(
                    servicer.ListServiceAccountKeys,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountKeysRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountKeysResponse.SerializeToString,
            ),
            'GetServiceAccountKey': grpc.unary_unary_rpc_method_handler(
                    servicer.GetServiceAccountKey,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.GetServiceAccountKeyRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccountKey.SerializeToString,
            ),
            'CreateServiceAccountKey': grpc.unary_unary_rpc_method_handler(
                    servicer.CreateServiceAccountKey,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.CreateServiceAccountKeyRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccountKey.SerializeToString,
            ),
            'UploadServiceAccountKey': grpc.unary_unary_rpc_method_handler(
                    servicer.UploadServiceAccountKey,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UploadServiceAccountKeyRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccountKey.SerializeToString,
            ),
            'DeleteServiceAccountKey': grpc.unary_unary_rpc_method_handler(
                    servicer.DeleteServiceAccountKey,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DeleteServiceAccountKeyRequest.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
            'DisableServiceAccountKey': grpc.unary_unary_rpc_method_handler(
                    servicer.DisableServiceAccountKey,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DisableServiceAccountKeyRequest.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
            'EnableServiceAccountKey': grpc.unary_unary_rpc_method_handler(
                    servicer.EnableServiceAccountKey,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.EnableServiceAccountKeyRequest.FromString,
                    response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            ),
            'SignBlob': grpc.unary_unary_rpc_method_handler(
                    servicer.SignBlob,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignBlobRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignBlobResponse.SerializeToString,
            ),
            'SignJwt': grpc.unary_unary_rpc_method_handler(
                    servicer.SignJwt,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignJwtRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignJwtResponse.SerializeToString,
            ),
            'GetIamPolicy': grpc.unary_unary_rpc_method_handler(
                    servicer.GetIamPolicy,
                    request_deserializer=google_dot_iam_dot_v1_dot_iam__policy__pb2.GetIamPolicyRequest.FromString,
                    response_serializer=google_dot_iam_dot_v1_dot_policy__pb2.Policy.SerializeToString,
            ),
            'SetIamPolicy': grpc.unary_unary_rpc_method_handler(
                    servicer.SetIamPolicy,
                    request_deserializer=google_dot_iam_dot_v1_dot_iam__policy__pb2.SetIamPolicyRequest.FromString,
                    response_serializer=google_dot_iam_dot_v1_dot_policy__pb2.Policy.SerializeToString,
            ),
            'TestIamPermissions': grpc.unary_unary_rpc_method_handler(
                    servicer.TestIamPermissions,
                    request_deserializer=google_dot_iam_dot_v1_dot_iam__policy__pb2.TestIamPermissionsRequest.FromString,
                    response_serializer=google_dot_iam_dot_v1_dot_iam__policy__pb2.TestIamPermissionsResponse.SerializeToString,
            ),
            'QueryGrantableRoles': grpc.unary_unary_rpc_method_handler(
                    servicer.QueryGrantableRoles,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryGrantableRolesRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryGrantableRolesResponse.SerializeToString,
            ),
            'ListRoles': grpc.unary_unary_rpc_method_handler(
                    servicer.ListRoles,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListRolesRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListRolesResponse.SerializeToString,
            ),
            'GetRole': grpc.unary_unary_rpc_method_handler(
                    servicer.GetRole,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.GetRoleRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.SerializeToString,
            ),
            'CreateRole': grpc.unary_unary_rpc_method_handler(
                    servicer.CreateRole,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.CreateRoleRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.SerializeToString,
            ),
            'UpdateRole': grpc.unary_unary_rpc_method_handler(
                    servicer.UpdateRole,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UpdateRoleRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.SerializeToString,
            ),
            'DeleteRole': grpc.unary_unary_rpc_method_handler(
                    servicer.DeleteRole,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DeleteRoleRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.SerializeToString,
            ),
            'UndeleteRole': grpc.unary_unary_rpc_method_handler(
                    servicer.UndeleteRole,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UndeleteRoleRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.SerializeToString,
            ),
            'QueryTestablePermissions': grpc.unary_unary_rpc_method_handler(
                    servicer.QueryTestablePermissions,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryTestablePermissionsRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryTestablePermissionsResponse.SerializeToString,
            ),
            'QueryAuditableServices': grpc.unary_unary_rpc_method_handler(
                    servicer.QueryAuditableServices,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryAuditableServicesRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryAuditableServicesResponse.SerializeToString,
            ),
            'LintPolicy': grpc.unary_unary_rpc_method_handler(
                    servicer.LintPolicy,
                    request_deserializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.LintPolicyRequest.FromString,
                    response_serializer=google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.LintPolicyResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'google.iam.admin.v1.IAM', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers('google.iam.admin.v1.IAM', rpc_method_handlers)


 # This class is part of an EXPERIMENTAL API.
class IAM(object):
    """Creates and manages Identity and Access Management (IAM) resources.

    You can use this service to work with all of the following resources:

    * **Service accounts**, which identify an application or a virtual machine
    (VM) instance rather than a person
    * **Service account keys**, which service accounts use to authenticate with
    Google APIs
    * **IAM policies for service accounts**, which specify the roles that a
    principal has for the service account
    * **IAM custom roles**, which help you limit the number of permissions that
    you grant to principals

    In addition, you can use this service to complete the following tasks, among
    others:

    * Test whether a service account can use specific permissions
    * Check which roles you can grant for a specific resource
    * Lint, or validate, condition expressions in an IAM policy

    When you read data from the IAM API, each read is eventually consistent. In
    other words, if you write data with the IAM API, then immediately read that
    data, the read operation might return an older version of the data. To deal
    with this behavior, your application can retry the request with truncated
    exponential backoff.

    In contrast, writing data to the IAM API is sequentially consistent. In other
    words, write operations are always processed in the order in which they were
    received.
    """

    @staticmethod
    def ListServiceAccounts(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/ListServiceAccounts',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountsRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountsResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def GetServiceAccount(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/GetServiceAccount',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.GetServiceAccountRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def CreateServiceAccount(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/CreateServiceAccount',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.CreateServiceAccountRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def UpdateServiceAccount(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/UpdateServiceAccount',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def PatchServiceAccount(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/PatchServiceAccount',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.PatchServiceAccountRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccount.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def DeleteServiceAccount(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/DeleteServiceAccount',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DeleteServiceAccountRequest.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def UndeleteServiceAccount(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/UndeleteServiceAccount',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UndeleteServiceAccountRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UndeleteServiceAccountResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def EnableServiceAccount(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/EnableServiceAccount',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.EnableServiceAccountRequest.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def DisableServiceAccount(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/DisableServiceAccount',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DisableServiceAccountRequest.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def ListServiceAccountKeys(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/ListServiceAccountKeys',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountKeysRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListServiceAccountKeysResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def GetServiceAccountKey(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/GetServiceAccountKey',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.GetServiceAccountKeyRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccountKey.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def CreateServiceAccountKey(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/CreateServiceAccountKey',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.CreateServiceAccountKeyRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccountKey.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def UploadServiceAccountKey(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/UploadServiceAccountKey',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UploadServiceAccountKeyRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ServiceAccountKey.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def DeleteServiceAccountKey(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/DeleteServiceAccountKey',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DeleteServiceAccountKeyRequest.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def DisableServiceAccountKey(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/DisableServiceAccountKey',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DisableServiceAccountKeyRequest.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def EnableServiceAccountKey(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/EnableServiceAccountKey',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.EnableServiceAccountKeyRequest.SerializeToString,
            google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def SignBlob(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/SignBlob',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignBlobRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignBlobResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def SignJwt(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/SignJwt',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignJwtRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.SignJwtResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def GetIamPolicy(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/GetIamPolicy',
            google_dot_iam_dot_v1_dot_iam__policy__pb2.GetIamPolicyRequest.SerializeToString,
            google_dot_iam_dot_v1_dot_policy__pb2.Policy.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def SetIamPolicy(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/SetIamPolicy',
            google_dot_iam_dot_v1_dot_iam__policy__pb2.SetIamPolicyRequest.SerializeToString,
            google_dot_iam_dot_v1_dot_policy__pb2.Policy.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def TestIamPermissions(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/TestIamPermissions',
            google_dot_iam_dot_v1_dot_iam__policy__pb2.TestIamPermissionsRequest.SerializeToString,
            google_dot_iam_dot_v1_dot_iam__policy__pb2.TestIamPermissionsResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def QueryGrantableRoles(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/QueryGrantableRoles',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryGrantableRolesRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryGrantableRolesResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def ListRoles(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/ListRoles',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListRolesRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.ListRolesResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def GetRole(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/GetRole',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.GetRoleRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def CreateRole(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/CreateRole',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.CreateRoleRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def UpdateRole(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/UpdateRole',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UpdateRoleRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def DeleteRole(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/DeleteRole',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.DeleteRoleRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def UndeleteRole(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/UndeleteRole',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.UndeleteRoleRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.Role.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def QueryTestablePermissions(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/QueryTestablePermissions',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryTestablePermissionsRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryTestablePermissionsResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def QueryAuditableServices(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/QueryAuditableServices',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryAuditableServicesRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.QueryAuditableServicesResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def LintPolicy(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/google.iam.admin.v1.IAM/LintPolicy',
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.LintPolicyRequest.SerializeToString,
            google_dot_iam_dot_admin_dot_v1_dot_iam__pb2.LintPolicyResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)
