import setuptools
import os
import glob

def find_package_data(base, globs, root="google-common-protos"):
	"""Find all interesting data files, for setup(package_data=)
	Arguments:
	  root:  The directory to search in.
	  globs: A list of glob patterns to accept files.
	"""

	rv_dirs = [root for root, dirs, files in os.walk(base)]
	rv = []
	for rv_dir in rv_dirs:
		files = []
		for pat in globs:
			files += glob.glob(os.path.join(rv_dir, pat))
		if not files:
			continue
		rv.extend([os.path.relpath(f, root) for f in files])
	return rv

package_data = find_package_data("google-common-protos", ["*.py", "*.pyi"])

setuptools.setup(
	name="google-common-protos",
	version="1.12.0",
	description="Protobufs generated by Alis Build",
	packages=setuptools.find_packages(),
	include_package_data=True,
	package_data={  # Optional
		"google": package_data,
	},

	install_requires=[
		
	]
)
